<?php
/**
*
*	Génère le mot de passe
*	28 février 2014
*	Version 1.0.0
*	Laurent Clavé laurent.clave@gmail.com
*
*/

// Charge la définition des carractères
require('charsConfig.php');

// Petite fonction qui converti une chaîne en booléen
function stringToBool($string){return $string=='true';}

// Validation
if($_SERVER['REQUEST_METHOD'] == 'POST'){

	$passSize 			= $_POST['passSize'];
	$mask 				= $_POST['mask'];
	$maskChar 			= $_POST['maskChar'];
	$forceUpper 		= stringToBool($_POST['forceUpper']);
	$ultra 				= $_POST['ultra'];// Si l'on veux rajouter une nouvelle liste de caractères
	$noLetters 			= false;
	$noInteger 			= stringToBool($_POST['noInteger']);
	$noSpecials			= stringToBool($_POST['noSpecials']);
	$noRepetition 		= stringToBool($_POST['noRepetition']);
	$noTypeConsecutive 	= stringToBool($_POST['noTypeConsecutive']);
	$forceAllTypes 		= stringToBool($_POST['forceAllTypes']);
	
	
	// Protège le serveur sur une demande improbable
	if($passSize>$maximumSize || strlen($mask)>$maximumSize)
			die('Nombre de caractères à génèrer trop important');

	

	if($ultra!='')$charsConfig['ultra']=$ultra;
	if($noLetters)unset( $charsConfig['letters'] );
	if($noInteger)unset( $charsConfig['integers'] );
	if($noSpecials)unset( $charsConfig['specials'] );

	$chars = $charsConfig;// On charge la liste dans une variable temporaire
	$typeCharsNb = array();// Tableau qui va contenir le nombre de types utilisés
	
	// Si un masque est défini la longeur est celle du masque
	if($mask != '')$passSize = strlen($mask);

	// Nombre de caractères à génèrer par type
	$maxCharsByType = round($passSize / count($chars));

	// Tableau des types
	$charTypes = array_keys( $chars );
	
	$upperCase=(rand(0,1)==0);// Défini au hasard si la première lettre sortie est en uppercase.
	$lastType='';
	$FINALPASS = '';
	// Algo de génération - On boucle sur chaque carractère du masque ou le nombre de carractères demandés
	for($i=0;$i<$passSize;$i++) {

		$charType = '';

		// Si le masque est défini et que le carractère n'est pas à génèrer
		if($mask != '' && $mask[$i] != $maskChar){
			$currentChar = $mask[$i];
			$FINALPASS .= $currentChar;
			// Si l'on doit utiliser tous les types dans notre génèration
			if($forceAllTypes){
				// On incrémente le compteur du type de carractère
				foreach ($charsConfig as $key => $charsByTypes) {	
				    if(substr_count($charsByTypes, $currentChar) > 0){
				    	$charType=$key; 
				    	break;
				    }
				}
			}
		// Sinon on génère le carractère
		}else{
			// On récupère les valeurs de type dont l'incrementation est inférieure au nombre max	
			$allowedTypes = $chars;
			foreach($chars as $type => $charsByTypes){
				if(isset($typeCharsNb[$type]) && $typeCharsNb[$type] >= $maxCharsByType)unset($allowedTypes[$type]);
			}	
			if(count($allowedTypes)==0)$allowedTypes = $chars;// Ce produit en cas de $maxCharsByType impair
			
			$tempAllowedTypes = $allowedTypes;
			// On selectionne un type au hasard sauf le dernier utilisé si on a plus d'un type de disponible
			if($noTypeConsecutive && $lastType != '' && count($tempAllowedTypes) > 1)unset($tempAllowedTypes[$lastType]);
			$charType = array_rand($tempAllowedTypes, 1);	

			// On récupère un caractère du type au hasard
			$randomedsChars = str_shuffle($chars[ $charType ]);// str_shuffle pas forcement utile
			$random = rand(0, strlen($randomedsChars)-1);

			$currentChar = $randomedsChars[$random];

			// Gestion de la casse
			if($forceUpper && $charType == 'letters'){
				if($upperCase)$currentChar = strtoupper($currentChar);
				$upperCase=!$upperCase;
			}
			
			// On l'assigne à la chaîne finale
			$FINALPASS .= $currentChar;
		}	

		$lastType = $charType;// Sauvegarde du type pour le prochain passage

		// Si l'on interdit la répètition de caractère, on supprime ceux qui sont déjà utilisés
		if($noRepetition){
			$chars[$charType] = str_replace(strtolower($currentChar), '', $chars[$charType]);
			if(strlen($chars[$charType]) == 0)$chars[$charType] = $charsConfig[$charType];// Si tous les caractères ont étés consommés, on repart de zero
		}
		
		// Si l'on doit forcer l'utilisation de tous les types, on incrémente par type
		if($forceAllTypes){
			// On compte le nombre de caractères par type
			if(isset($typeCharsNb[$charType]))$typeCharsNb[$charType]++;else $typeCharsNb[$charType] = 1;
		}

	}

	// On affiche le mot de passe afin qu'il soit traîté par JSON
	echo $FINALPASS ;
}
	
?>