$(function(){

	function genPass(timeout){
		if(timeout == undefined)timeout=0;
		var mask = $('#maskType').is(":visible") ? $('#mask').val() : '';
		$.ajax({
		  url: "genpass.php",
		  type: "POST",
		   data: { 
	        'passSize': $('#passSize').val(),
	        'mask': mask,
	        'maskChar': $('#maskChar').val(),
	        'noInteger': ! $('#allowInteger').is(':checked'),
	        'noSpecials': ! $('#allowSpecials').is(':checked'),
	        'forceUpper' : $('#forceUpper').is(':checked'),
	        'forceAllTypes' : $('#forceAllTypes').is(':checked'),
	        'noTypeConsecutive' : $('#noTypeConsecutive').is(':checked'),
	        'noRepetition' : $('#noRepetition').is(':checked')
	    	}
		}).done(function(pass) {
		  $( '#password' ).val(pass);
		  testPass(pass);
		  if(timeout>=1000)setTimeout(function(){genPass(timeout)}, timeout);
		});

		
	}

	function setProgressBar(value){

		if(value>100)value=100;

		$('#pctLabel').html(value+'%');

		$('#bar1').css('width', 0);
		$('#bar2').css('width', 0);
		$('#bar3').css('width', 0);

		if(value<30)
			$('#bar3').css('width', value+'%');
		else if(value<60)
			$('#bar2').css('width', value+'%');
		else
			$('#bar1').css('width', value+'%');
	}


	function testPass(password){
		$.ajax({
		  url: "testpass.php",
		  type: "POST",
		   data: { 
	        'pass':password
	    	}
		}).done(function(jsonResult) {
			var details = jQuery.parseJSON(jsonResult);

			var total = 0;

			$('#passwordDetails').empty();
			function addLine(test, number, pts){
				total+=pts;
				var alertClass='';

				if(pts>0){
					alertClass='positive';
					pts='+'+pts;
				}
				else if(pts==0)alertClass='zero';
				else if(pts<0)alertClass='negative';
			
				$('#passwordDetails').append('<tr><td>'+test+'</td><td>'+number+'</td><td class="pts '+alertClass+'">'+pts+'</td></tr>');
			}

			addLine('Taille', details.size, details.size*4);
			addLine('Lettres', details.nbLetters, details.nbLetters);
			addLine('Chiffres', details.nbIntegers, details.nbIntegers*4);
			addLine('Symboles', details.nbSpecials, details.nbSpecials*6);
			addLine('Minuscules', details.nbLowerCase, details.nbLowerCase);
			addLine('Majuscules', details.nbUpperCase, details.nbUpperCase==0?0:(details.size-details.nbUpperCase)*3);
			addLine('Consécutifs', details.nbConsecutif, -(details.nbConsecutif * 10));
			addLine('Répétitions', details.nbRepetition, -(details.nbRepetition * 8));
			addLine('types consécutifs', details.nbTypeConsecutive, -(details.nbTypeConsecutive * 4));

			setProgressBar(total);
		});
	}



	$(this).on("keyup change click", "input", function(event){  
		if($(this).prop('id') != 'password')genPass();
	})

	$('#detailsTable').hide();
	
	genPass();//genPass(1000); pour faire tourner en boucle - à voir ?

	$(this).on("change", ".switchType", function(event){  
		$('#numberType').toggle();
		$('#maskType').toggle();
		genPass();
	})

	$(this).on("click", "#refreshBtn",genPass);
	
	$(this).on("click", "#showDetails",function(){
		$('#detailsTable').fadeToggle();
	});

});


